<?php

include(dirname(__FILE__).'/../../config/config.inc.php');
include(dirname(__FILE__).'/../../header.php');
include_once(dirname(__FILE__).'/mabnapayment2.php');

if (!$cookie->isLogged())
	Tools::redirect('authentication.php?back=order.php');     
$currency_default = Currency::getCurrency(intval(Configuration::get('PS_CURRENCY_DEFAULT')));        
$mabnapayment2= new mabnapayment2(); // Create an object for order validation and language translations
@session_start();

$paymentId = isset($_GET["paid"]) ? $_GET['paid'] : 0;

$order_cart = new Cart(intval($paymentId));

$purchase_currency = new Currency(Currency::getIdByIsoCode('IRR'));		
$current_currency = new Currency(Context::getContext()->cookie->id_currency);
if($current_currency->id==$purchase_currency->id)
	$PurchaseAmount= number_format($cart->getOrderTotal(true, 3), 0, '', '');		 
else
	$PurchaseAmount= number_format(Tools::convertPrice($cart->getOrderTotal(true, 3), $purchase_currency), 0, '', '');

if(isset($_POST['respcode']) && $_POST['respcode'] == '0' )
{
	$terminal =trim(Configuration::get('MABNA2_TER'));
	$_POST['digitalreceipt'] = filter_var($_POST['digitalreceipt'], FILTER_SANITIZE_STRING);  
	$sql = "SELECT COUNT(*) FROM `"._DB_PREFIX_."message` WHERE `message`  LIKE '%".$_POST['digitalreceipt']."%'";
	$ress =  Db::getInstance()->getValue($sql);
		
	if($ress == 0)
	{
		$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		$result = json_decode($res,true);
		 if (strtoupper($result['Status']) == 'OK') 
		 {
					 
			 if( floatval($result['ReturnId']) == floatval($PurchaseAmount) )
			{
					$referenceId = $_POST['digitalreceipt'];
					$paid = $mabnapayment2->validateOrder((int)$paymentId, _PS_OS_PAYMENT_, (float)Context::getContext()->cart->getOrderTotal(true, 3), $mabnapayment2->displayName, "سفارش تایید شده / کد رهگیری :".$referenceId , array(),(int)Context::getContext()->currency->id, false);			
					Tools::redirect('index.php?controller=history');
				
			 }
			else
			{
				$res = 'مبلغ واریز با قیمت محصول برابر نیست ، مبلغ واریزی :'.$result['ReturnId'];
				echo $mabnapayment2->error($mabnapayment2->l($res));
			}
		}else
		{
			switch($result['ReturnId'])
			{
				case '-1' : $res = 'تراکنش پیدا نشد';break;
				case '-2' : $res = 'تراکنش قبلا Reverse شده است';break;
				case '-3' : $res = 'خطا عمومی';break;
				case '-4' : $res = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
				case '-5' : $res = 'آدرس IP پذیرنده نامعتبر است';break;
				default  : $res = 'خطای ناشناس : '.$result['ReturnId'];break;
				
			}
			echo $mabnapayment2->error($mabnapayment2->l($res));
		}
	}
	else
	{
		echo $mabnapayment2->error($mabnapayment2->l('رسید قبلا استفاده شده است'));
	}
}
else
{
	$err = 'برگشت ناموفق از درگاه';
	echo $mabnapayment2->error($mabnapayment2->l($err));
}
include_once(dirname(__FILE__).'/../../footer.php');		

?>